#!/usr/bin/env python
# -*- coding: utf-8 -*-

import sys, os, string, time#,codecs, re
PYVERSION = string.split(string.split(sys.version)[0], ".")

try:
	from qt import Qt, SIGNAL, SLOT, QTimer, QApplication, QThread, QIconSet, QCursor, QToolTip, QPopupMenu, QDialog, QLabel, QMessageBox, QSize, QColor, QCustomEvent, QEvent, QRect, QVBox, QHBox, QVBoxLayout, QPushButton, QPixmap #, QSettings ,qApp
	#from qt import *
	#from qtsql import *
except:
	print "this application requires the 'pyqt' module."
	try:
		os.popen("kdialog --sorry 'this application requires the pyqt module.'")
		sys.exit()
	except:
		sys.exit()
try:
	from kdecore import KApplication, KIcon, KIconLoader, KAboutData, KCmdLineArgs
	from kfile import KFileDialog
	from kdeui import KMainWindow, KSystemTray, KDialog, KMessageBox, KListViewItem, KAboutApplication, KPassivePopup, KListView, KGuiItem
except:
	print "this application requires the 'pykde' module."
	try:
		os.popen("kdialog --sorry 'this application requires the pykde module.'")
		sys.exit()
	except:
		sys.exit()

if int(PYVERSION[0]) == 2 and int(PYVERSION[1]) < 5:
	try:
		from pysqlite2 import dbapi2 as sqlite
	except:
		print "this application requires the 'pysqlite' module."
		try:
			os.popen("kdialog --sorry 'this application requires the pysqlite module.'")
			sys.exit()
		except:
			sys.exit()
else:
	from sqlite3 import dbapi2 as sqlite

from ui_mainwindow import MainWindow
from ui_dialogs import showWaitForm, settingsFormNew, accountForm, showEmailsForm
from ConfigParser import *
import poplib, socket, email.Parser, email.Message, email.Header#, email.Charset, quopri

#from email.Errors import HeaderParseError
#from email.Header import decode_header, make_header
#from encodings import exceptions as exceptions_codage

#import locale
#locale.setlocale(locale.LC_ALL, 'fr_FR')
#locale.setlocale(locale.LC_TIME, "en_GB")
#print sys.getdefaultencoding()
#sys.setdefaultencoding('latin-1')
#import StringIO, rfc822


# Global Variables definition
DEFAULT_CHAR_ENCODING = "utf-8"
DEFAULT_EXTERNAL_APP = "kmail"
DEFAULT_AUDIO_WAVE_FILE = "/opt/kde3/share/sounds/KDE_Window_Iconify.wav"
DEFAULT_AUDIO_PLAYER = "aplay --nonblock --quiet "
HOMEDIR = os.path.expanduser("~")
CONFIG_DIR = HOMEDIR + "/" + ".kpopassistant"
DB_PATH = CONFIG_DIR + "/" + "mailboxes.db"
CONFIG_FILERC = CONFIG_DIR + "/kpopassistantrc"
MAXLINES = 80000 # max message size when previewing it

# Create app's settings dir
if not os.path.exists(CONFIG_DIR):
	print "config dir not found, creating it."
	try:
		os.mkdir(CONFIG_DIR)
	except:
		os.popen("kdialog --sorry 'Could not create directory in home folder.\nSettings can't be saved. App will quit now.'")
		sys.exit()

# Headers we're actually interrested in
"""
rx_date = re.compile(r"^(Date)")
rx_from = re.compile(r"^(From)")
rx_subject = re.compile(r"^(Subject)")
rx_multipart = re.compile(r"^(Content-Type)")
"""
#rx_headers  = re.compile(r"^(From|To|Subject)")

# --------------------------- GLOBAL ROUTINES----------------------------------

"""
def getCurrentTimeFromQt():
	# provoque des UnicodeEncodeError et UnicodeDecodeError apres update de pyqt sur suse 10.1
	tt = QTime()
	dd = QDate()
	#print tt.currentTime().hour()
	#print dd.currentDate().day()
	day = dd.currentDate().toString(Qt.TextDate)
	hours = tt.currentTime().toString(Qt.TextDate)
	now = str(day) + ", " + str(hours)
	return now

def dbGetAccountsListQt():
	db = QSqlDatabase.addDatabase("QSQLITE")
	#db.setHostName("/root/.kpopwatcher")
	#db.setDatabaseName("mailboxes.db")
	db.setHostName("")
	db.setDatabaseName("/root/.kpopwatcher/mailboxes.db")
	
	if db.open():
		#cur = db.cursor()
		query = QSqlQuery('SELECT name FROM accounts')
		#query = QSqlQuery()
		#query.prepare("SELECT name FROM accounts")
		
		#query = db.execStatement('SELECT name FROM accounts')
		#print query.execQuery()
		
		accountList = []
	
		while (query.next()):
			print "yopi"
			accountList.append(query.value(0).toString())
			
		db.close()
		
		return accountList
	else:
		sys.exit()

def encodestring(instring, tabs=0):
	outfile = StringIO.StringIO()
	quopri.encode(StringIO.StringIO(instring), outfile, tabs)
	return outfile.getvalue()

def decodestring(instring):
	outfile = StringIO.StringIO()
	quopri.decode(StringIO.StringIO(instring), outfile)
	return outfile.getvalue()

def decodeHeaderMoinsOld(string):
	# decode encoded charsets found in emails
	
	parts = email.Header.decode_header(string)
	
	try:
		new_header = email.Header.make_header(parts)
		decoded = unicode(new_header)
	except:
		decoded = unicode("", "utf-8")
		for z in parts:
			try:
				if z[1] is None:	# no need to decode, this is plain text
					decoded = decoded + unicode(z[0], "utf-8")
				#else:				# need to decode according to specified encoding
				#	decoded = decoded + unicode(z[0].decode(z[1]))
			except:
				decoded = decoded + unicode("???", "utf-8")

	decoded = decoded.replace("\n", "")
	decoded = decoded.replace("\t", "")
	
	return decoded

def decodeHeaderOld(string):
	# decode encoded charsets found in emails
	
	parts = email.Header.decode_header(string)
	
	try:
		new_header = email.Header.make_header(parts)
		decoded = unicode(new_header)
	except:
		decoded = unicode("")
		for z in parts:
			try:
				if z[1] is None:	# no need to decode, this is plain text
					decoded = decoded + unicode(z[0])
				else:				# need to decode according to specified encoding
					decoded = decoded + unicode(z[0].decode(z[1]))
			except:
				decoded = decoded + unicode("???")

	decoded = decoded.replace("\n", "")
	decoded = decoded.replace("\t", "")
	
	return decoded
"""

def decodeHeader(string):
	""" get the message's subject as a unicode string """
	#s = self.getheader("Subject")
	try:
		return u"".join(map(lambda x: x[0].decode(x[1] or 'ASCII', 'replace'),
							email.Header.decode_header(string)))
	except(LookupError):
		return string

def dbGetAccountsList():
	accountList = []
	
	con = sqlite.connect(DB_PATH)
	cur = con.cursor()
	cur.execute('SELECT name FROM accounts')
	
	for row in cur:
		accountList.append(row[0])
		
	con.close()
	
	return accountList

def dateIsToday(dateString):
	"""compare dateString and current time & say if dateString is Today's date"""
	
	# split mail dateString in bits
	parts = dateString.lower().replace(',', '').split()
	try:
		dayMail = int(parts[1])
		monthMail = parts[2]
		yearMail = parts[3]
		hourMail = parts[4]
	except:
		return dateString
	
	# get current time (IN ENGLISH, for universal purpose) and split it in 'bits'
	bits = time.asctime().lower().split()
	try:
		dayToday = int(bits[2])
		monthToday = bits[1]
		yearToday = bits[4]
		#hourToday = bits[3]
	except:
		return dateString
	
	# compare email & today parts to check if mail's date is today's date
	if (dayMail == dayToday) and (monthMail == monthToday) and (yearMail == yearToday):
		return "Today, " + hourMail
	else:
		return dateString
	
def getCurrentTime():
	#now = time.asctime(time.localtime())
	now = time.localtime(time.time())
	year, month, day, hour, minute, second, weekday, yearday, daylight = now
	
	dateString = str(time.strftime("%A %d %B %Y", now)) + ", " + str("%02d:%02d:%02d" % (hour, minute, second))
	
	return dateString.decode(DEFAULT_CHAR_ENCODING)

def _connect2Mailbox(servername, username, pwd, port, servertype):
	connexerror = False
	try:
		if servertype == 0 or servertype == "" or servertype is None:
			if port == "" or port is None:
				port = "110"
			server = poplib.POP3(servername, int(port))
		elif servertype == 1:
			if port == "" or port is None:
				port = "995"
			server = poplib.POP3_SSL(servername, int(port), None, None)
		else:
			connexerror = True
		
		if not connexerror:
			#print server.getwelcome()
			server.user(username)
			server.pass_(pwd)
		
	except poplib.error_proto:
		print "Unable to connect to host. Quitting"
		connexerror = True
	except socket.gaierror:
		print "Unable to connect to host. Quitting"
		connexerror = True
	except socket.error:
		print "Unable to connect to host. Quitting"
		connexerror = True
	
	if connexerror == True:
		return "error"
	else:
		return server

# ----------------------------------------------------------------------

class KPopAssistant(MainWindow):
	def __init__(self,parent):
		MainWindow.__init__(self,parent)
		self.layout10.setItemEnabled(0,False)
		self.layout10.setItemEnabled(2,False)
		self.layout10.setItemEnabled(3,False)
		self.exitFlag = False
		self.exitFlagFromSystray = False
		self.altLedPix = False
		self.mainTimer = QTimer(self)
		self.initialTimer = QTimer(self)
		self.ledTimer = QTimer(self)
		self.mailboxBeingChecked = False
		self.newMailDialogShown = False
		self.mailboxes = []
		self.firstTimeLoaded = True
		#self.setAutoSaveSettings()
		#self.evtDeleteEmailList = QEvent.Type(QEvent.User)
		
		# Read & apply settings from config file if present
		c = manageConfigFile()
		if not os.path.exists (CONFIG_FILERC):
			c.buildDefaultConfigRCFile(self)

		if not os.path.exists (DB_PATH):
			c.buildDatabase()

		self.loadSettings()
		
		# display mailbox(es) content in listViews
		if len ( self.mailboxes ) > 0:
			if self.initialTimerTime > 1:
				self.displayMailboxes(False) # only listView1 (accounts summary)
				self.layout10.setItemEnabled(0,True)
				self.layout10.setItemEnabled(2,True)
				self.layout10.setItemEnabled(3,True)
			else:
				self.displayMailboxes(True) # listView1 & listView2 (accounts summary + messages list)

		# init systray and slots
		self._initSystray()
		self._connectSlots()
		#self.playAudioWaveFile()
		
	def _connectSlots(self):
		#self.connect(self.listView2, SIGNAL("clicked(QListViewItem*)"), self.titlesChecked)
		#self.connect(self.listView2,SIGNAL("doubleClicked(QListViewItem*)"),self.showTitleInfo)
		#self.connect(self.listView1,SIGNAL("clicked(QListViewItem*,const QPoint&,int)"),self.onMailBoxSelected)
		#self.connect(self, SIGNAL('hide()'), self.tutut)
		self.connect(self.listView1,SIGNAL("selectionChanged(QListViewItem*)"),self.onMailBoxSelected)
		self.connect(self.listView1,SIGNAL("rightButtonClicked(QListViewItem*,const QPoint&,int)"),self.displayItemContextMenu1)
		self.connect(self.listView2,SIGNAL("rightButtonClicked(QListViewItem*,const QPoint&,int)"),self.displayItemContextMenu2)
		self.connect(self.listView2,SIGNAL("doubleClicked(QListViewItem*,const QPoint&,int)"),self.showEmails)
		self.connect(self.layout10, SIGNAL("clicked(int)"), self.toolBarClicked)
		self.connect(self.mainTimer,SIGNAL('timeout()'), self.mainTimerTimeOutSlot)
		self.connect(self.ledTimer, SIGNAL('timeout()'), self.ledTimerTimeOutSlot)
		self.connect(self.initialTimer, SIGNAL('timeout()'), self.initialTimerTimeOutSlot)
		#self.connect(self.pbCancel, SIGNAL("clicked()"), self, SLOT("close()"))self.slotQuitSelected)

	def errHandler(self):
		pass
	
	def toolBarClicked(self, btnId):
		#print "button pressed :",btnId
		action = {
				0: self.checkMail,
				1: self.showSettingsDialog,
				2: self.showEmails,
				3: self.deleteEmails,
				4: self.markAllEmailsAsRead,
				5: self.composeEmail,
				6: self.launchExternalApp,
				7: self.showAboutDialog,
				8: self.minimizeWindow,
				9: self.timeToQuit
				}
		action.get(btnId, self.errHandler)()
	
	def _initSystray(self):
		self.systray = KSystemTray(self)
		
		# Look for unread messages in mailboxes and set appropriate systray icon & other GUI
		self.unreadMessagesFound()

		# Load context menu icons
		kicl = KIconLoader()
		imRun = kicl.loadIconSet("run", KIcon.Small)
		imMailNew = kicl.loadIconSet("mail_send", KIcon.Small)
		imReload = kicl.loadIconSet("reload", KIcon.Small)
		imConfigure = kicl.loadIconSet("configure", KIcon.Small)
		imIdea = kicl.loadIconSet("messagebox_info", KIcon.Small)

		# Build context menu
		self.systray.contextMenu().insertItem(imRun,"&Launch " + self.externalAppName, self.launchExternalApp, Qt.CTRL+Qt.Key_L,1,1)
		self.systray.contextMenu().insertItem(imMailNew,"&Compose an e-mail with Kmail", self.composeEmail, Qt.CTRL+Qt.Key_C)
		self.systray.contextMenu().insertItem(imReload,"&Refresh messages", self.checkMail, Qt.CTRL+Qt.Key_R)
		self.systray.contextMenu().insertItem(imConfigure,"&Settings", self.showSettingsDialog, Qt.CTRL+Qt.Key_S)
		self.systray.contextMenu().insertItem(imIdea,"&About", self.showAboutDialog, Qt.CTRL+Qt.Key_A)
		"""
		self.systray.contextMenu().insertItem(QIconSet(self.imRun),"&Launch " + self.externalAppName, self.launchExternalApp, Qt.CTRL+Qt.Key_L,1,1)
		self.systray.contextMenu().insertItem(QIconSet(self.imMailNew),"&Compose an e-mail with Kmail", self.composeEmail, Qt.CTRL+Qt.Key_C)
		self.systray.contextMenu().insertItem(QIconSet(self.imReload),"&Refresh messages", self.checkMail, Qt.CTRL+Qt.Key_R)
		self.systray.contextMenu().insertItem(QIconSet(self.imConfigure),"&Settings", self.showSettingsDialog, Qt.CTRL+Qt.Key_S)
		self.systray.contextMenu().insertItem(QIconSet(self.imIdea),"&About", self.showAboutDialog, Qt.CTRL+Qt.Key_A)
		"""
		
		self.systray.connect (self.systray, SIGNAL("quitSelected()"), self.slotQuitSelected)
		
		#self.systray.contextMenu().changeItem(1,"toto")
		self.systray.contextMenu().setItemEnabled(1,self.itemState)
		
		self.systray.show()

	def showPassivePopup(self, mode=0):
		#popupStyle = 0
		#popui = KPassivePopup( popupStyle, self.systray )
		popui = KPassivePopup( self.systray )
		popui.setView("EMAIL INCOMING", "New mail has arrived !", self.imMailNew)
		popui.setTimeout(5000)
		popui.setAutoDelete(True)
		"""
		vb = QVBox(popui)
		#box0 = QHBox( vb )
		label1 = QLabel( vb, "label1" )
		label1.setPixmap(self.imMailNew)
		#label1.setPixmap(QPixmap(self.imMailNew))
		#label.setIcon(self.image2)
		label1.setText("<p align=center><b>EMAIL INCOMING</b></p>")
		
		labelEmpty1 = QLabel(vb, "labelEmpty1")
		labelEmpty1.setText("")
		
		label2 = QLabel( vb, "label2" )
		label2.setText("<p align=center><i>New mail has arrived !</i></p>")
		
		labelEmpty2 = QLabel(vb, "labelEmpty2")
		labelEmpty2.setText("")
		#label = QPushButton( box0, "label" )
		#label.setText("<b>EMAIL INCOMING</b>")
		#label.setIconSet(QIconSet(self.image0))
		#label.setFlat(True)
		
		box = QHBox( vb )
		yes = QPushButton( box, "yes" )
		yes.setText("Show window")
		no = QPushButton( box, "no" )
		no.setText("Preview mail")
		#maybe = QPushButton( box, "maybe" )
		#maybe.setText("Maybe")
		#maybe.setIconSet(QIconSet(self.image0))
		self.connect(yes, SIGNAL('clicked()'), self.bringToFront)
		self.connect(no, SIGNAL('clicked()'), self.showEmails)
		#self.connect(maybe, SIGNAL('clicked()'), self.bringToFront)
		popui.setView(vb)
		"""
		#popui.message(0, "toto", "Raoul", None, None)
		popui.show()

	def bringToFront(self):
		self.hide()
		self.show()
		self.setFocus()
		#self.setWindowState()
		#self.showNormal()
		self.setActiveWindow()
		#self.setShown(True)
		#self.setHidden(False)

	def queryClose(self):
		""" queryClose() : this protected function is always checked after the close button is hit and before the application quits """
		mustQuitNow = False
		
		#if self.exitFlagFromSystray == True: # exits from sysTray -> confirmClose becomes redondant
			#mustQuitNow = True
		#elif self.exitFlag == True: # exit from exit button in toolbar
			#mustQuitNow = True
		if self.exitFlagFromSystray or self.exitFlag:
			mustQuitNow = True
		else: # exit requested from window top-right corner close button -> mapped hide app in systray
			self.hide()
			return False
		
		if self.confirmClose == 1 and self.exitFlag:
			quitBtn = KGuiItem("&Quit", "", "", "")
			cancelBtn = KGuiItem("&Cancel", "", "", "")
			choice = KMessageBox.warningYesNo(self, "Do you really want to quit KPopAssistant ?", "Quit Application", quitBtn, cancelBtn )
			if choice == 4: # if user says 'no'
				mustQuitNow = False
			else:
				mustQuitNow = True
		else:
			mustQuitNow = True
		
		# GoodBye now or not
		if mustQuitNow == True:
			if self.saveUi == 1:
				self.saveUiConfigFile() # saving ui in configfilerc if applies
			return True # quit app now
		else:
			self.exitFlag = False
			return False # don't quit app
	
	def slotQuitSelected (self):
		"""request close from SysTray"""
		#self.exitFlag = True
		self.exitFlagFromSystray = True
		
	
	def timeToQuit (self):
		self.exitFlag = True
		#self.saveMainWindowSettings( "Form1", True)
		#KApplication.kApplication ().quit ()
		self.close() # quits application for good
	
	def setBusy(self, mode):
		if mode == True:
			self.setCursor( QCursor(3) ) # change mouse cursor shape
			self.listView1.setEnabled(False)
			self.listView2.setEnabled(False)
			self.layout10.setItemEnabled(0,False)
			self.layout10.setItemEnabled(2,False)
			self.layout10.setItemEnabled(3,False)
			self.layout10.setItemEnabled(4,False)
			#self.led.setText("BUSY")
			self.led.setPixmap(self.imNetRx)
			self.ledTimer.start(500)
		else:
			self.setCursor( QCursor(0) ) # restore mouse cursor shape
			self.listView1.setEnabled(True)
			self.listView2.setEnabled(True)
			self.layout10.setItemEnabled(0,True)
			self.layout10.setItemEnabled(2,True)
			self.layout10.setItemEnabled(3,True)
			self.layout10.setItemEnabled(4,True)
			self.ledTimer.stop()
			self.altLedPix = False
			self.led.setPixmap(self.imNetNone)
			#self.led.setText("")
	
	def customEvent(self,event):
		# delete mails requested from showEmailsDialog
		"""
		if event.type() == self.evtDeleteEmailList:
			self.mailboxBeingChecked = True
			self.setCursor( QCursor(3) ) # change mouse cursor shape
			self.deleteMailThread = _deleteMailThread(self, None, event.data())
			self.deleteMailThread.start()
			self.showWaitDialog("Deleting Mail ...", "Please wait while deleting mail ...", 300, 60)
		"""
		
		# simply update status bar message with data coming from thread
		if event.type() == 42000:
			self.statusBar.message(event.data())
		
		# checkMail thread has stopped and is a success
		if event.type() == 40000:
			self.mailboxBeingChecked = False
			
			# reload mailboxes
			self.mailboxes = event.data()
			
			# look for new incoming messages in mailboxes
			newMessagesFound = 0 # new messages are actually unread messages
			freshMessagesFound = 0 # fresh messages are just arrived emails
			for item in self.mailboxes:
				newMessagesFound += item.newMessages
				freshMessagesFound += len(item.newItems)
			
			#newMessagesStr = "new : %s / unread : %s" % (str(freshMessagesFound), str(newMessagesFound))
			todate = getCurrentTime().split(",")
			
			# GUI update
			#self.setDisabled(False)
			self.setBusy(False)
			self.statusBar.message( "-> last mail check completed on " + todate[0] + " at" + todate[1] )
			#self.statusInfo.setText(newMessagesStr)
			self.unreadMessagesFound() # update SysTray's icon & tool tips
			
			# update SysTray's ToolTip & emit beep sound if freshMessagesFound
			if freshMessagesFound > 0:
				print "new mail has arrived"
				self.playAudioWaveFile()
				self.showPassivePopup()
				
				#os.popen2('aplay --nonblock --quiet "/opt/kde/share/sounds/KDE_Dialog_Disappear.wav"')
				#QApplication.beep() # emits a beep sound, qt way
				#print "\a" # emits a beep sound, python way
				
				#QToolTip.add(self.systray, " " + str(freshMessagesFound) + " new e-mail(s) found <br> " + str(newMessagesFound) + " unread e-mail(s) are waiting " )
				"""
				if self.newMailDialogShown == False:
					if self.isActiveWindow() == False:
						self.newMailDialogShown = True
						self.systray.setPixmap (self.imMailNew)
						choice = QMessageBox.information(self, "Mail notification", "NEW MAIL HAS ARRIVED !", "Ignore", "Show main window")
						self.systray.setPixmap (self.image3)
						self.newMailDialogShown = False
						if choice == 1:
							if self.isMinimized():
								self.showNormal()
								self.setVisible(True)
								self.setActiveWindow()
							else:
								self.show()
				"""
			
			# update timers
			if self.mainTimer.isActive():
				self.mainTimer.stop()
			self.mainTimer.start( 60000 * self.mainTimerTime )
			
			self.displayMailboxes(False)
		
		# delete mail thread has stopped
		if event.type() == 50000:
			self.mailboxBeingChecked = False
			self.waitDialog.close()
			self.setBusy(False)
			# TODO : an event.type should provide info about which account has had email deleted + how many emails + handle possible errors deleting emails
			if event.data() == "error":
				print "Connection error occured"
				self.statusBar.message("Could not connect to mailbox ! Please check your settings or your internet connection.")
				self.led.setPixmap(self.imNetErr)
			else:
				# successfully delete uids in event.data() from server
				#print event.data()
				self.updateMailbox()

			if not self.mainTimer.isActive():
				self.mainTimer.start( 60000 * self.mainTimerTime )
			
		# Connection to mailbox error occured (from delete thread) - INUTILE
		if event.type() == 60000:
			self.mailboxBeingChecked = False
			self.waitDialog.close()
			self.setBusy(False)
			
			print "Connection error occured"
			self.statusBar.message("Could not connect to mailbox ! Please check your settings or your internet connection.")
			self.led.setPixmap(self.imNetErr)
			
			if not self.mainTimer.isActive():
				self.mainTimer.start( 60000 * self.mainTimerTime )

	def updateMailbox(self):
		"""delete mail thread has stopped -> update GUI & values"""
		self.statusBar.message("> mail has been successfully deleted")
		
		# update current mailbox
		self.mailboxes[self.accountSelected] = mailboxFromFile(self.mailboxes[self.accountSelected].accountname)
		
		# update listView1 (accounts summary)
		self.accountHeader[self.accountSelected].setText(3, str(self.mailboxes[self.accountSelected].numMessages))
		if self.mailboxes[self.accountSelected].newMessages == 0:
			self.accountHeader[self.accountSelected].setText(4, "-")
		else:
			self.accountHeader[self.accountSelected].setText(4, str(self.mailboxes[self.accountSelected].newMessages))
		self.accountHeader[self.accountSelected].setText(5, str( int(self.mailboxes[self.accountSelected].size) / 1024 ) + " Kb")
		
		# update listView2 (messages list)
		self.displayMessagesList()
		
		# look for unread messages in mailboxes and set appropriate systray icon & other GUI
		self.unreadMessagesFound()

	def mainTimerTimeOutSlot(self):
		self.mainTimer.stop()
		if self.mailboxBeingChecked == False:
			self.checkMail()
	
	def initialTimerTimeOutSlot(self):
		self.initialTimer.stop()
		if self.mailboxBeingChecked == False:
			self.checkMail()

	def ledTimerTimeOutSlot(self):
		if self.altLedPix == False:
			self.led.setPixmap(self.imNetTx)
			self.altLedPix = True
		else:
			self.led.setPixmap(self.imNetRx)
			self.altLedPix = False

	def minimizeWindow(self):
		#self.showMinimized()
		self.hide()
	
	#def onMailBoxSelected(self, item, qpoint, column):
	def onMailBoxSelected(self, item):
		#print "level 1"
		if item:
			#print "level 2"
			# finds which item is currently selected
			for i in range ( len(self.accountHeader) ):
				if self.accountHeader[i].isSelected():
					#print "level 3"
					if self.accountSelected != i:
						self.accountSelected = i
						self.displayMessagesList() # display items in LISTVIEW #2

	def displayItemContextMenu1(self, item, qpoint, column):
		# display a context pop-up menu whenever a listView1 Item is right-clicked
		if item: # only show popup menu if an item is actually selected, i.e. not only blank space selected in the listView
			# Load context menu icons
			kicl = KIconLoader()
			imReload = kicl.loadIconSet("reload", KIcon.Small)
			
			# set up context menu
			contextMenu = QPopupMenu( self )
			contextMenu.insertItem(imReload,"&Refresh mailbox", self.checkOneMailbox, Qt.CTRL+Qt.Key_R)
			contextMenu.exec_loop( QCursor.pos() )

	def displayItemContextMenu2(self, item, qpoint, column):
		# display a context pop-up menu whenever a listView2 Item is right-clicked
		if item: # only show popup menu if an item is actually selected, i.e. not only blank space selected in the listView
			# Load context menu icons
			kicl = KIconLoader()
			imApply = kicl.loadIconSet("apply", KIcon.Small)
			imMailDelete = kicl.loadIconSet("mail_delete", KIcon.Small)
			imMailFind = kicl.loadIconSet("mail_find", KIcon.Small)
			
			# set up context menu
			contextMenu = QPopupMenu( self )
			contextMenu.insertItem(imMailFind,"&Show selected message(s)", self.showEmails, Qt.CTRL+Qt.Key_S)
			contextMenu.insertItem(imMailDelete,"&Delete selected message(s)", self.deleteEmails, Qt.CTRL+Qt.Key_D)
			contextMenu.insertItem(imApply,"&Mark message(s) as read", self.markEmailsAsRead, Qt.CTRL+Qt.Key_M)
			"""
			contextMenu.insertItem(QIconSet(self.image1),"&Show selected message(s)", self.showEmails, Qt.CTRL+Qt.Key_S)
			contextMenu.insertItem(QIconSet(self.image2),"&Delete selected message(s)", self.deleteEmails, Qt.CTRL+Qt.Key_D)
			contextMenu.insertItem(QIconSet(self.image6),"&Mark message(s) as read", self.markEmailsAsRead, Qt.CTRL+Qt.Key_M)
			"""
			contextMenu.exec_loop( QCursor.pos() )

	def showEmails(self):
		# check if items to be previewed are selected
		if len(self.mailboxes[self.accountSelected].item) > 0:
			countSelected = 0
			countNew = 0
			index = 0
			uids2ShowSelected = []
			uids2ShowNew = []
			for item in self.item:
				if item.isSelected():
					countSelected += 1
					uids2ShowSelected.append(self.mailboxes[self.accountSelected].item[index].uid)
				if str(item.text(1)) == "NEW":
					countNew += 1
					uids2ShowNew.append(self.mailboxes[self.accountSelected].item[index].uid)
				index += 1
			
			"""
			if countSelected > 20 or countNew > 20:
				continueBtn = KGuiItem("&Continue", "", "", "")
				cancelBtn = KGuiItem("&Abandon", "", "", "")
				choice = KMessageBox.warningYesNo(self, "You are about to retrieve more than 20 messages.\nThis may take some time.\nContinue anyway ?", "Retrieve mail", continueBtn, cancelBtn )
				if choice == 4: # if user says 'no'
					return
			"""
			
			if countSelected < 1 and countNew < 1:
				print "preview e-mail(s) : no new or selected message(s) to display"
				return
			
			# show selected messages instead of new ones if applies
			if countSelected > 0:
				mode = None
				uids2Show = uids2ShowSelected
				if countSelected > 20:
					continueBtn = KGuiItem("&Continue", "", "", "")
					cancelBtn = KGuiItem("&Abandon", "", "", "")
					choice = KMessageBox.warningYesNo(self, "You are about to retrieve more than 20 messages.\nThis may take some time.\nContinue anyway ?", "Retrieve mail", continueBtn, cancelBtn )
					if choice == 4: # if user says 'no'
						return
			else:
				mode = "new"
				uids2Show = uids2ShowNew
				if countNew > 20:
					continueBtn = KGuiItem("&Continue", "", "", "")
					cancelBtn = KGuiItem("&Abandon", "", "", "")
					choice = KMessageBox.warningYesNo(self, "You are about to retrieve more than 20 messages.\nThis may take some time.\nContinue anyway ?", "Retrieve mail", continueBtn, cancelBtn )
					if choice == 4: # if user says 'no'
						return
			
			# finally, show emails preview dialog
			serverInfos = [self.mailboxes[self.accountSelected].accountname, self.mailboxes[self.accountSelected].servername, self.mailboxes[self.accountSelected].username, self.mailboxes[self.accountSelected].password, self.mailboxes[self.accountSelected].port, self.mailboxes[self.accountSelected].servertype]
			self.showEmailsDialog = showEmailsDialog(self, serverInfos, uids2Show)

			self.showEmailsDialog.show()

	def showSettingsDialog(self):
		self.settingsDialog = showSettingsDialog(self)
		self.settingsDialog.show()
	
	def showWaitDialog(self, title, text, width, height):
		self.waitDialog = QDialog(self, 'waitDialog', 1, 0)
		self.waitDialog.setCaption(title)
		self.waitDialog.resize(QSize(width,height).expandedTo(self.minimumSizeHint()))
		self.waitDialog.setMaximumHeight(height)
		self.waitDialog.setMaximumWidth(width)
		self.waitDialog.setMinimumHeight(height)
		self.waitDialog.setMinimumWidth(width)
		self.waitDialog.clearWState(Qt.WState_Polished)
		
		waitLabel = QLabel(self.waitDialog, 'waitLabel')
		waitLabel.setGeometry(QRect(10,6,width-10,46))
		waitLabel.setText('<p align="center"><font color=#0046D5>' + text + '</font></p>')
		
		self.waitDialog.show()

	def showConfirmDialog(self, title, text, button1text, button2text):
		choice = QMessageBox.warning( self, title, text, button1text, button2text )
		return choice

	def showAboutDialog(self):
		#self.showPassivePopup(2)
		dlg = KAboutApplication(self, "about kpopassistant", True)
		dlg.show()
	
	def launchExternalApp(self):
		if self.externalApp.strip() != '':
			os.popen2(self.externalApp)
			print "external app launched"
	
	def composeEmail(self):
		#if self.externalApp != '':
		print "launching Kmail compose window."
		os.popen2("kmail --composer")
		#else:
		#	print "External application has not been specified. Please check your settings."

	def loadSettings(self):
		# read settings from config file(s), load values (-> update GUI)
		if os.path.exists(CONFIG_FILERC):
			
			#myconfig = QSettings(CONFIG_FILERC)
			#myconfig.beginGroup("DEFAULT")
			#print str( myconfig.readEntry("bonobo", "default bonobo") )
			#myconfig.endGroup()
			#myconfig = None
			
			self.configfile = ConfigParser()
			self.configfile.read(CONFIG_FILERC)
			self.startMinimized = int( self.configfile.defaults()['startminimized'] )
			self.startMaximized = int( self.configfile.defaults()['startmaximized'] )
			self.saveUi = int( self.configfile.defaults()['saveui'] )
			self.confirmClose = int( self.configfile.defaults()['confirmclose'] )
			self.confirmDelete = int( self.configfile.defaults()['confirmdelete'] )
			self.mainTimerTime = int( self.configfile.defaults()['maintimer'] )
			self.initialTimerTime = int( self.configfile.defaults()['intervaltimer'] )
			self.column1 = int( self.configfile.defaults()['column1'] )
			self.column2 = int( self.configfile.defaults()['column2'] )
			self.column3 = int( self.configfile.defaults()['column3'] )
			self.xwidth = int( self.configfile.defaults()['width'] )
			self.xheight = int( self.configfile.defaults()['height'] )
			self.xxpos = int( self.configfile.defaults()['xpos'] )
			self.xypos = int( self.configfile.defaults()['ypos'] )
			self.accountSelected = int( self.configfile.defaults()['lastaccountselected'] )
			self.externalApp = self.configfile.defaults()['externalapp']
			self.externalAppName = self.externalApp.split()[0]
			try:
				self.audioWaveFile = self.configfile.defaults()['audiowavefile']
			except:
				self.audioWaveFile = DEFAULT_AUDIO_WAVE_FILE

			
			if self.externalApp != '':
				self.itemState = True
				#self.systray.contextMenu().setItemEnabled(1,False)
			else:
				self.itemState = False
				#self.systray.contextMenu().setItemEnabled(1,True)
				
			#self.listView1.setMaximumHeight(int( self.configfile.defaults()['listview1height']) )
			#self.listView1.setFixedHeight(int( self.configfile.defaults()['listview1height'])  )
			
			#self.resize( QSize( self.xwidth, self.xheight ).expandedTo( self.minimumSizeHint() ) )
			
			#self.listView1.resize( self.listView1.width(), int( self.configfile.defaults()['listview1height'])  )
			#self.listView2.resize( self.listView2.width(), int( self.configfile.defaults()['listview2height'])  )
			#self.listView2.setColumnWidth( 2, self.column1 )
			#self.listView2.setColumnWidth( 3, self.column2 )
			#self.listView2.setColumnWidth( 4, self.column3 )
			
			# get mailbox(es) available in DB
			self.accountConfigFileList = dbGetAccountsList()
			self.mailboxes = []
			for filename in self.accountConfigFileList:
				self.mailboxes.append(mailboxFromFile(filename))
			
			if len ( self.mailboxes ) <= 1 or self.accountSelected > (len( self.mailboxes )-1) :
				self.accountSelected = 0

			# launch timers for mailbox check
			if len ( self.mailboxes ) > 0: # if at least one account exists
				self.layout10.setItemEnabled(0,True)
				self.layout10.setItemEnabled(2,True)
				self.layout10.setItemEnabled(3,True)
				if not self.mainTimer.isActive():
					self.mainTimer.start( 60000 * self.mainTimerTime )
				#self.initialTimer.start( 1000 * self.initialTimerTime )
			
			if self.firstTimeLoaded:
				self.resize( QSize( self.xwidth, self.xheight ).expandedTo( self.minimumSizeHint() ) )
				self.listView1.resize( self.listView1.width(), int( self.configfile.defaults()['listview1height'])  )
				self.listView2.resize( self.listView2.width(), int( self.configfile.defaults()['listview2height'])  )
				self.listView2.setColumnWidth( 2, self.column1 )
				self.listView2.setColumnWidth( 3, self.column2 )
				self.listView2.setColumnWidth( 4, self.column3 )
				
				if len ( self.mailboxes ) > 0: # if at least one account exists
					self.initialTimer.start( 1000 * self.initialTimerTime )
				
				self.firstTimeLoaded = False
	
	def deleteEmails(self):
		# check if items to be deleted are selected
		#index = 0
		if len(self.mailboxes[self.accountSelected].item) > 0:
			countSelected = 0
			#uids2Delete = []
			for item in self.item:
					if item.isSelected():
						countSelected += 1
						#uids2Delete.append(self.mailboxes[accountSelected].item[index].uid)
				#index += 1
			
			if countSelected == 0: # none selected, do nothing
				print "delete email(s) : no selected item(s) to delete"
				return

			# ask for the user to confirm
			if self.confirmDelete == 1:
				deleteBtn = KGuiItem("&Delete", "", "", "")
				cancelBtn = KGuiItem("&Cancel", "", "", "")
				choice = KMessageBox.warningYesNo(self, "You're about to delete %s messages from server.\nProceed with e-mail deletion ?" % (str(countSelected)), "Confirm mail deletion", deleteBtn, cancelBtn )
				if choice == 4: # if user says 'no'
					return

			# initiate deletion process
			self.setBusy(True)
			self.mailboxBeingChecked = True
			self.deleteMailThread = _deleteMailThread(self, None, None)
			self.deleteMailThread.start()
			self.statusBar.message("> " + self.mailboxes[self.accountSelected].accountname + " : deleting mail...")
			self.showWaitDialog("Deleting Mail ...", "Please wait while deleting mail ...", 300, 60)

	def checkOneMailbox(self):
		""" check just one mailbox for new mail """
		if not self.mailboxBeingChecked:
			print "please wait while checking mail for", self.mailboxes[self.accountSelected].accountname, "..."
			
			# GUI update
			self.setBusy(True)
			self.statusBar.message( "-> checking mail for account '%s' ..." %  self.mailboxes[self.accountSelected].accountname )
			self.systray.setPixmap (self.image4)
			QToolTip.add(self.systray, " please wait while mailboxes are being checked ... ")
			
			# launching thread
			self.mailboxBeingChecked = True
			specifiedAccount = self.accountSelected
			self.checkMailThread = _checkMailThread(self, specifiedAccount)
			self.checkMailThread.start()
		else:
			print "mailbox busy"
			KMessageBox.error(self, "Maibox is busy.\nPlease try again later.","Maibox busy" )
	
	def checkMail(self):
		""" check all mailboxes for new mail """
		if len(self.mailboxes) > 0 :
			if self.mailboxBeingChecked == False:
				print "please wait while checking mail ..."
				if self.mainTimer.isActive():
					self.mainTimer.stop()
			
				# GUI update
				self.setBusy(True)
				self.statusBar.message( "-> checking mail ..." )
				self.systray.setPixmap (self.image4)
				QToolTip.add(self.systray, " please wait while mailbox is being checked ... ")
				
				# launching thread
				self.mailboxBeingChecked = True
				specifiedAccount = None
				self.checkMailThread = _checkMailThread(self, specifiedAccount)
				self.checkMailThread.start()
			else:
				print "mailbox busy"
				KMessageBox.error(self, "Maibox is busy.\nPlease try again later.","Maibox busy" )
		else:
			KMessageBox.error(self, "You must register at least one e-mail account before refreshing messages.\nPlease check your settings.","Accounts not set" )

	def markAllEmailsAsRead(self):
		if len(self.mailboxes) > 0:
			if self.mailboxes[self.accountSelected].newMessages > 0:
				# get account name
				accountName = self.mailboxes[self.accountSelected].accountname
				
				# update DB
				con = sqlite.connect(DB_PATH)
				cur = con.cursor()
				cur.execute("UPDATE mailboxes SET new=0 WHERE new=1 AND account=?", (accountName,))
				con.commit()
				con.close()
	
				# update mailbox(es) items value
				for item in self.mailboxes[self.accountSelected].item:
					item.new = 0
					
				self.mailboxes[self.accountSelected].newMessages = 0
				
				# update gui
				for item in self.item:
					if str(item.text(1)) == "NEW":
						item.setText(1, "")
				
				self.accountHeader[self.accountSelected].setText(4, "-")
				
				# look for unread messages in mailboxes and set appropriate systray icon
				self.unreadMessagesFound()

	def markEmailsAsRead(self):
		if len(self.mailboxes) > 0:
			# get account name
			accountName = self.mailboxes[self.accountSelected].accountname
			
			# retrieve messages that will be marked as read (using uid)
			uids2Delete = []
			index = 0
			for item in self.item:
				if item.isSelected() and self.mailboxes[self.accountSelected].item[index].new==1:
						uids2Delete.append(self.mailboxes[self.accountSelected].item[index].uid)
						self.mailboxes[self.accountSelected].item[index].new = 0
						item.setText(1,"")
				index += 1
			
			# update DB
			if len(uids2Delete) > 0:
				con = sqlite.connect(DB_PATH)
				cur = con.cursor()
				
				for uid in uids2Delete:
					cur.execute("UPDATE mailboxes SET new=0 WHERE account=? AND uid=?", (accountName, uid))
	
				con.commit()
				con.close()
				
				self.mailboxes[self.accountSelected].newMessages = self.mailboxes[self.accountSelected].newMessages - len(uids2Delete)
				if self.mailboxes[self.accountSelected].newMessages == 0:
					self.accountHeader[self.accountSelected].setText(4, "-")
				else:
					self.accountHeader[self.accountSelected].setText(4, str(self.mailboxes[self.accountSelected].newMessages))
			
			# look for unread messages in mailboxes and set appropriate systray icon
			self.unreadMessagesFound()

	def unreadMessagesFound(self):
		""" look for unread messages in all mailboxes and set appropriate systray icon & other GUI """
		
		# get updated values
		unreadMessagesFound = 0 # new messages are actually unread messages
		freshMessagesFound = 0 # fresh messages are just arrived emails
		for item in self.mailboxes:
			unreadMessagesFound += item.newMessages
			freshMessagesFound += len(item.newItems)
			
		statusStr = "new : %s / unread : %s" % (str(freshMessagesFound), str(unreadMessagesFound))
		
		# update gui
		self.statusInfo.setText(statusStr)

		if unreadMessagesFound > 0:
			self.systray.setPixmap ( self.imMailNew )
			self.layout10.setItemEnabled(4,True)
			if freshMessagesFound > 0:
				QToolTip.add(self.systray, " " + str(freshMessagesFound) + " new e-mail(s) found <br> " + str(unreadMessagesFound) + " unread e-mail(s) are waiting " )
			else:
				QToolTip.add(self.systray, " " + str(unreadMessagesFound) + " unread e-mail(s) are waiting ")
		else:
			self.systray.setPixmap ( self.image3 )
			QToolTip.add(self.systray, " no new mail ")
			self.layout10.setItemEnabled(4,False)
		
		#return unreadMessagesFound

	def displayNewMailbox(self, mailbox):
		self.accountConfigFileList.append(mailbox.accountname)
		self.mailboxes.append(mailbox)
		self.displayMailboxes(True)

	def displayMailboxes(self, headersOnly):
		""" display content of mailbox(es) into the listViews """
		self.listView1.clear()
		
		if len(self.mailboxes) > 0:
	
			# LISTVIEW #1
			self.listView1.setSorting(-1)
			#self.listView1.setPaletteBackgroundColor ( QColor(245,245,245) )
			
			self.accountHeader = []
			
			# find mailbox config file(s) available in CONFIG_DIR
			#self.accountConfigFileList = dbGetAccountsList()
			#self.mailboxes = []
			#for filename in self.accountConfigFileList:
			#	self.mailboxes.append( mailboxFromFile(filename) )
			#	self.accountHeader.append( KListViewItem(self.listView1,None) )
			
			for mailbox in self.mailboxes:
				self.accountHeader.append( KListViewItem(self.listView1,None) )
			
			itemIndex = 0
			for i in self.accountHeader:
				# get new messages' information
				newMessages = str(self.mailboxes[itemIndex].newMessages)
				if newMessages == "0":
					newMessages = "-"
				
				# display values
				i.setText(0, self.mailboxes[itemIndex].accountname)
				i.setText(1, self.mailboxes[itemIndex].servername)
				i.setText(2, self.mailboxes[itemIndex].username)
				i.setText(3, str(self.mailboxes[itemIndex].numMessages))
				i.setText(4, newMessages)
				i.setText(5, str( int(self.mailboxes[itemIndex].size) / 1024 )  + " Kb")
				i.setText(6, self.mailboxes[itemIndex].lastcheck)
				
				itemIndex += 1
				
			#self.accountHeader[self.accountSelected].setSelected(True)
			self.listView1.setSelected(self.accountHeader[self.accountSelected], True) # works better than above
			
			# LISTVIEW #2
			if headersOnly == False:
				self.displayMessagesList()

	def displayMessagesList(self):
		""" display messages in LISTVIEW2 """
		self.listView2.clear()
		self.listView2.setSorting(-1)
		
		#self.listView2.setSorting(0, False)
		#self.listView2.sort()
		#self.listView2.setAlternateBackground( QColor(248, 248, 248) )
		
		itemIndex = self.accountSelected
		self.item = []
		index = ''
		count = 0
		for i in range ( len(self.mailboxes[itemIndex].item) ):
			self.item.append( KListViewItem(self.listView2,None) )
			#self.item.append( RichTextItem(self.listView2,None) )
			
			# filter email's index
			#if i < 9:
			#	index = '0' + str (i+1)
			#else:
			#	index = str (i+1)
			index = str(i+1)
			
			# filter email sender's name
			_pos = self.mailboxes[itemIndex].item[i].sender.find("<")
			if _pos > 0:
				_from = self.mailboxes[itemIndex].item[i].sender[:_pos]
			else:
				_from = self.mailboxes[itemIndex].item[i].sender
			
			# filter email's size
			size = int(self.mailboxes[itemIndex].item[i].size)
			if size >= 1024:
				msize = str (size/1024) + " MB"
			elif size < 1024:
				msize = str (size) + " kb"
			else:
				msize = "1 kb"

			# update NEW column if necessary
			if self.mailboxes[itemIndex].item[i].new == 1:
				self.item[i].setText(1, 'NEW')
				count += 1
			
			# check whether mail is multipart and set matching pixmap
			if self.mailboxes[itemIndex].item[i].isMultipart:
				self.item[i].setPixmap(2,self.imMailAttach)
			else:
				self.item[i].setPixmap(2,self.image0)
			
			self.item[i].setText(0, index)
			self.item[i].setText(2, _from)
			self.item[i].setText(3, self.mailboxes[itemIndex].item[i].subject)
			self.item[i].setText(4, dateIsToday(self.mailboxes[itemIndex].item[i].date))
			self.item[i].setText(5, msize)
			self.item[i].setText(6, self.mailboxes[itemIndex].accountname)
			#list_item = RichTextItem(self.listView2, None)
			#list_item.setText(5, "<b>" + str(mailbox.item[i].size) + "</b>")

	def saveUiConfigFile(self):
		# saves ConfileFileRC before app quits.
		print "saved UI config file before app quits."
		if self.isMaximized() == False:
			startMaximized = "0"
		else:
			startMaximized = "1"
		
		new_conf = open( CONFIG_FILERC, 'w' )
		new_conf.write( '[DEFAULT]\n' )
		new_conf.write( 'startminimized = ' + str( self.startMinimized ) + '\n' )
		new_conf.write( 'saveui = ' + str( self.saveUi) + '\n' )
		new_conf.write( 'confirmclose = ' + str( self.confirmClose ) + '\n' )
		new_conf.write( 'confirmdelete = ' + str( self.confirmDelete ) + '\n' )
		new_conf.write( 'intervaltimer = ' + str( self.initialTimerTime ) + '\n' )
		new_conf.write( 'maintimer = ' + str( self.mainTimerTime ) + '\n' )
		new_conf.write( 'startmaximized = ' + startMaximized + '\n' )
		new_conf.write( 'listview1height = ' + str( self.listView1.height() ) + '\n' )
		new_conf.write( 'listview2height = ' + str( self.listView2.height() ) + '\n' )
		new_conf.write( 'column1 = ' + str( self.listView2.columnWidth(2) ) + '\n' )
		new_conf.write( 'column2 = ' + str( self.listView2.columnWidth(3)  ) + '\n' )
		new_conf.write( 'column3 = ' + str( self.listView2.columnWidth(4)  ) + '\n' )
		new_conf.write( 'width = ' + str( self.width() ) + '\n' )
		new_conf.write( 'height = ' + str( self.height() ) + '\n' )
		new_conf.write( 'xpos = ' + str( self.x() ) + '\n' )
		new_conf.write( 'ypos = ' + str( self.y() ) + '\n' )
		new_conf.write( 'lastaccountselected = ' + str( self.accountSelected ) + '\n' )
		new_conf.write( 'externalapp = ' + self.externalApp + '\n' )
		new_conf.write( 'audiowavefile = ' + self.audioWaveFile + '\n' )
		new_conf.close()
	
	def playAudioWaveFile(self):
		# play audio wave file when new mail arrives
		
		#self.audioWaveFile = "sounds/KDE_Window_Iconify.wav"
		print "playing external audio wave file :", self.audioWaveFile.strip()

		if self.audioWaveFile.strip() == "" or self.audioWaveFile is None:
			QApplication.beep() # emits a beep sound, qt way
		elif os.path.exists(self.audioWaveFile.strip()):
			#os.popen2('aplay --nonblock --quiet ' + self.audioWaveFile.strip())
			os.popen2(DEFAULT_AUDIO_PLAYER + self.audioWaveFile.strip())
		else:
			QApplication.beep() # emits a beep sound, qt way


#------------------------------------------------------------------

class _retrieveMailThread(QThread):
	def __init__(self, receiver, serverInfos, uids2Show):
		QThread.__init__(self)
		self.receiver = receiver
		self.serverInfos = serverInfos
		self.uids2Show = uids2Show
		self.error = False
		self.stopped = False
	
	def run(self):
		# connect to pop server
		server = _connect2Mailbox( self.serverInfos[1], self.serverInfos[2], self.serverInfos[3], self.serverInfos[4], self.serverInfos[5] )
		
		# check for a pop connection error
		if server == "error":
			self.error = True
		else:
			messageContent = []
			self.messageUid = []
			self.messageDecoded = []
			self.messageSource = []
			self.messageNumber = [] # message index on server
			
			# get uid of individual message and append it in a list
			uids = []
			uidList = server.uidl()[1]

			for i in range ( len(uidList) ):
				uidOfEmail = uidList[i].split()
				uids.append(uidOfEmail[1])
				
			# retreive matching uids from server
			for idx in range (len(uids)):
				if uids[idx] in self.uids2Show:
					self.messageNumber.append( idx + 1 )
					try:
						#response, lines, bytes = server.top(idx+1, MAXLINES)
						bytes = int( server.list( idx + 1 ).split()[2] )
						if bytes <= MAXLINES:
							content = server.retr( idx + 1 )[1]
							_message , _from, _subject = self.decodeMessage(content)
							_index = idx + 1
							_uid = uids[idx]
							_messageDecoded = _message
							_messageSource = '\n'.join(content)
							#_toggled = False
							
							messageContent.append( emailPreviewContent(_index, _uid, _from, _subject, _messageDecoded, _messageSource) )
						else:
							messageContent.append ( emailPreviewContent(0,'','','','Message was too big. Maximum message size set to  %s lines.' % str(MAXLINES), '') )
					except:
						messageContent.append ( emailPreviewContent(0,'','','','sorry, network error occured retrieving this e-mail', '') )
			
		try:
			server.quit()
		except: pass
		
		event = QCustomEvent( 81000 )
		if self.error:
			event.data("error")
		else:
			event.setData( messageContent )
		QThread.postEvent( self.receiver, event )
		
		self.stopped = True

	def decodeMessage(self, body):
		""" Build message as a string to be displayed in a QTextEdit """
		p = email.Parser.Parser()
		msg = p.parsestr('\n'.join(body), headersonly=False)

		_from = decodeHeader(msg.__getitem__("from"))
		_subject = decodeHeader(msg.__getitem__("subject"))
		
		content = u"FROM : " + decodeHeader(msg.__getitem__("from")) + u"\n"
		#content = u"<b>Received from :</b> " + QString(msg.__getitem__("from")) + u"<br>"
		content += u"ON : " + str(msg.__getitem__("date")) + u"\n\n"

		content += u"SUBJECT : " + decodeHeader(msg.__getitem__("subject")) + u"\n\n"
		
		# get e-mail body
		isAlternative = False
		hasAttach = False
		
		for part in msg.walk():
			if part.get_content_type().endswith('alternative'):
				isAlternative = True
				
			if part.get_content_type().startswith('text'):
				
				if part.get_content_type().endswith('plain'):
					#charset = msg.get_content_charset()
					charset = part.get_content_charset()
					#print "main type", msg.get_charset()
					if charset is None:
						#content += part.get_payload(decode=1).decode('utf-8')
						content += decodeHeader(part.get_payload(decode=1))
					else:
						#content += part.get_payload().decode(charset)
						#content += decodeHeader(part.get_payload(decode=1))
						content += unicode(part.get_payload(decode=1), charset)
						#content +=  unicode (part.get_payload(decode=1).decode(charset))
				
				if part.get_content_type().endswith('html') and isAlternative == False:
					try:
						content += unicode(part.get_payload().decode('utf-8') )
					except:
						content += u"-- html message --"
					
			if not part.get_content_type().startswith('text') and not part.get_content_type().startswith('multipart'):
				hasAttach = True

		return content, _from, _subject

class _deleteMailThread(QThread):
	def __init__(self, receiver, serverInfos, itemsList):
		QThread.__init__(self)
		self.receiver = receiver
		self.serverInfos = serverInfos
		self.itemsList = itemsList
		self.error = False
		self.stopped = False
	
	def run(self):
		if self.itemsList is None:
			uids2Delete = self.getUidsFromParent()
		else:
			uids2Delete = self.itemsList
		
		if self.serverInfos is None:
			server = _connect2Mailbox( self.receiver.mailboxes[self.receiver.accountSelected].servername, self.receiver.mailboxes[self.receiver.accountSelected].username, self.receiver.mailboxes[self.receiver.accountSelected].password, self.receiver.mailboxes[self.receiver.accountSelected].port, self.receiver.mailboxes[self.receiver.accountSelected].servertype )
			accountName = self.receiver.mailboxes[self.receiver.accountSelected].accountname
		else:
			server = _connect2Mailbox( self.serverInfos[1], self.serverInfos[2], self.serverInfos[3], self.serverInfos[4], self.serverInfos[5] )
			accountName = self.serverInfos[0]
		
		if server == "error":
			self.error = True
		else:
			# get uid of individual message and append it in a list
			uidList = server.uidl()[1]
			uids = []
			for i in range ( len(uidList) ):
				uidOfEmail = uidList[i].split()
				uids.append(uidOfEmail[1])

			uids2Remove = []
			# retrieve matching uids from server, find right index & delete email on pop server
			for idx in range (len(uids)):
				if uids[idx] in uids2Delete:
					try:
						server.dele(idx+1) # remove item from pop server
						uids2Remove.append(uids[idx])
					except:
						print "could not delete mail because uid was not found in messages list"
			
			try:
				accountSize = server.stat()[1]
				server.quit()
			except:
				accountSize = None
			
			# remove items from DB
			if len (uids2Remove) > 0:
				self.removeItemsFromDB(accountName, accountSize, uids2Remove)
			
			"""
			event = QCustomEvent(50000)
			event.setData(uids2Remove)
			QThread.postEvent(self.receiver, event)
			time.sleep(0.2) # time for main app to receive signal and close waitDialog
			# au lieu, ptet sauvegarder la voulle liste et faire un mailbox from file ?
			# ou alors blinder la routine checkmail
			self.stopped = True
			"""
		event = QCustomEvent(50000)
		if self.error:
			event.setData("error")
		else:
			event.setData(uids2Remove) # uids that have been actually removed
		QThread.postEvent(self.receiver, event)
		time.sleep(0.2) # time for main app to receive signal and close waitDialog
		# au lieu, ptet sauvegarder la voulle liste et faire un mailbox from file ?
		# ou alors blinder la routine checkmail
		self.stopped = True
	
	def getUidsFromParent(self):
		uids2Delete = []
		for i in range ( len(self.receiver.item) ):
			if self.receiver.item[i].isSelected():
				uids2Delete.append(self.receiver.mailboxes[self.receiver.accountSelected].item[i].uid)
		
		return uids2Delete

	def removeItemsFromDB(self, accountName, accountSize, uids2Remove):
		""" Remove entries from DB """
		con = sqlite.connect(DB_PATH)
		cur = con.cursor()
		
		mailboxName = accountName
		
		for uid in uids2Remove:
			cur.execute( "DELETE FROM mailboxes WHERE uid=? AND account=?", (uid, mailboxName) )
		if accountSize is not None:
			cur.execute( "UPDATE accounts SET size=? WHERE name=?", (accountSize, mailboxName))
		
		con.commit()
		con.close()

class _checkMailThread(QThread):
	def __init__(self, receiver, specifiedAccount):
		QThread.__init__(self)
		self.specifiedAccount = specifiedAccount
		self.receiver = receiver
		self.stopped = False
	
	def run(self):
		# check if we have to retrieve one or multiple mailboxe(s) from pop server(s)
		if self.specifiedAccount is None:
			self.accounts = self.receiver.mailboxes
			self.boxes = []
		else:
			self.boxes = self.receiver.mailboxes
			self.accounts = []
			self.accounts.append( self.receiver.mailboxes[self.specifiedAccount] )
		
		boxCount = 0
		for account in self.accounts:
			boxCountDisplay = " (" + str(boxCount+1) + "/" + str(len(self.accounts)) + ")"
			
			event = QCustomEvent( 42000 )
			event.setData( "checking mail for account " + account.accountname + boxCountDisplay + " ..." )
			QThread.postEvent( self.receiver, event )

			self.box = mailboxFromPop(account)
			
			if self.box.error == True: # Et self.box = "error" alors ?!?! a checker + tard
				print "mailbox connection error occured for", account.accountname
				#self.box = mailboxFromFile( boxFileName[boxCount]  )
				self.box = account
				self.box.lastcheck = "connection failed"
				#event = QCustomEvent(60000)
				#event.setData( self.box )
				#QThread.postEvent(self.receiver, event)
			else:
				self.listOfNewMails = []
				self.newMails = 0
				config = manageConfigFile()
				config.saveMailList( account.accountname, self.box )
				
				if len (self.box.newItems) > 0:
					print 'new mails :', len (self.box.newItems), 'for account', account.accountname
					#event = QCustomEvent(17000)
					#QThread.postEvent(self.receiver, event)
				
				if self.box.newMessages == 0:
						print "no new mail for account", account.accountname
				
				config = None
				
				#self.box.newMessages = len (self.box.newItems)
				
				#self.box.newMessagesList = self.box.newItems
				#self.stopped = True
				
				# thread has completed, inform main window
				#event = QCustomEvent(40000)
				#event.setData( self.box )
				#QThread.postEvent(self.receiver, event)
				
			if self.specifiedAccount is None:
				self.boxes.append( self.box )
			else:
				self.boxes[self.receiver.accountSelected] = self.box
			
			self.box = None
			boxCount += 1

		# thread has completed
		self.stopped = True
		print "check complete."
		
		# inform main app loop & update main window
		event = QCustomEvent( 40000 )
		event.setData( self.boxes )
		QThread.postEvent( self.receiver, event )

""" definitions of the emailContent class, i.e. what's inside an email object """
class emailContent:
	def __init__(self, uid, date, sender, subject, size, multipart, new):
		self.uid = uid
		self.date = date
		self.sender = sender
		self.subject = subject
		self.size = str(size)
		self.isMultipart = multipart
		self.new = new

class emailPreviewContent:
	def __init__(self, index, uid, sender, subject, messageDecoded, messageSource, toggled=False):
		#self.date = date
		self.index = index
		self.uid = uid
		self.sender = sender
		self.subject = subject
		self.messageSource = messageSource
		self.messageDecoded = messageDecoded
		self.message = messageDecoded
		self.toggled = toggled
		self.deleted = False

class manageConfigFile:
	def buildDefaultConfigRCFile(self, parent):
		new_conf = open( CONFIG_FILERC, 'w' )
		new_conf.write( '[DEFAULT]\n' )
		new_conf.write( 'startminimized = 0' + '\n' )
		new_conf.write( 'saveui = 1' + '\n' )
		new_conf.write( 'confirmclose = 1' + '\n' )
		new_conf.write( 'confirmdelete = 1' + '\n' )
		new_conf.write( 'intervaltimer = 2' + '\n' )
		new_conf.write( 'maintimer = 3' + '\n' )
		new_conf.write( 'startmaximized = 0' + '\n' )
		new_conf.write( 'listview1height = 45' + '\n' )
		#new_conf.write( 'listview2height = ' + str( parent.listView2.height() ) + '\n' )
		new_conf.write( 'listview2height = 120\n' )
		new_conf.write( 'column1 = ' + str( parent.listView2.columnWidth(2) ) + '\n' )
		new_conf.write( 'column2 = ' + str( parent.listView2.columnWidth(3) ) + '\n' )
		new_conf.write( 'column3 = ' + str( parent.listView2.columnWidth(4) ) + '\n' )
		new_conf.write( 'width = ' +  str( parent.width() ) + '\n' )
		new_conf.write( 'height = ' + str( parent.height() ) + '\n' )
		new_conf.write( 'xpos = ' +  str( parent.x() ) + '\n' )
		new_conf.write( 'ypos = ' + str( parent.y() ) + '\n' )
		new_conf.write( 'lastaccountselected = 0\n' )
		new_conf.write( 'externalapp = ' + DEFAULT_EXTERNAL_APP + '\n' )
		new_conf.write( 'audiowavefile = ' + DEFAULT_AUDIO_WAVE_FILE + '\n' )
		new_conf.close()

	def buildDatabase(self):
		con = sqlite.connect(DB_PATH)
		cur = con.cursor()
		cur.execute( "CREATE TABLE accounts(host TEXT, lastcheck TEXT, name TEXT, password TEXT, size NUMERIC, user TEXT, port NUMERIC, type NUMERIC)" )
		cur.execute( "CREATE TABLE mailboxes(account TEXT, date TEXT, multipart NUMERIC, new NUMERIC, sender TEXT, size NUMERIC, subject TEXT, uid TEXT)" )
		con.commit()
		con.close()

	def saveMailList(self, configfile, mail):
		"""save/update/sync entries in DB"""
		
		# update accounts DB
		con = sqlite.connect(DB_PATH)
		cur = con.cursor()
		cur.execute("UPDATE accounts SET size=?, lastcheck=? WHERE name=?", (mail.size, mail.lastcheck, configfile))
		con.commit()

		# store all uids from DB in a list, for comparison purposes
		cur.execute("SELECT uid FROM mailboxes WHERE account=?", (configfile,))
		uids = []
		for row in cur:
			uids.append(row[0])

		# save new emails in DB
		for item in mail.item:
			if not item.uid in uids:
				if item.isMultipart:
					multipart = 1
				else:
					multipart = 0

				#subject = item.subject.replace("'", "''")
				#sender = item.sender.replace("'", "''")
				cur.execute("INSERT INTO mailboxes (account, date, multipart, new, sender, size, subject, uid) VALUES (?, ?, ?, ?, ?, ?, ?, ?)", (configfile, item.date, multipart, 1, item.sender, item.size, item.subject, item.uid))

		# SYNC LOCAL DB WITH ONLINE POP SERVER : ici faire une comparison des uids stockes et des uids en ligne (sur le serveur)
		# -> enlever les lignes dont les uids ne correspondent plus avec celles en ligne.
		for uid in uids:
			if not uid in mail.uids:
				cur.execute("DELETE FROM mailboxes WHERE account=? AND uid=?", (configfile, uid))
				print "syncing DB for uid", uid

		con.commit()
		con.close()

	def readMailList(self, configfile):
		#self.configfile = configfile
		emailObject = []
		
		con = sqlite.connect(DB_PATH)
		cur = con.cursor()
		cur.execute("SELECT uid, date, sender, subject, size, multipart, new FROM mailboxes WHERE account=?",(configfile,))

		for row in cur:
			emailObject.append( emailContent (row[0], row[1], row[2], row[3], row[4], row[5], row[6]) )
		
		con.close()
		return emailObject

class mailboxFromPop:
	# build a mailbox from the pop server
	def __init__(self, mailbox):
		self.configfile = mailbox.accountname
		self.accountname = mailbox.accountname
		self.servername = mailbox.servername
		self.username = mailbox.username
		self.password = mailbox.password
		self.port = mailbox.port
		self.servertype = mailbox.servertype
		self.error = False

		self.mailbox = mailbox
		self.mustBeSaved = False
		self.newItems = []
		self.newMessages = 0
		self.lastcheck = getCurrentTime()
		self.server = _connect2Mailbox(mailbox.servername, mailbox.username, mailbox.password, mailbox.port, mailbox.servertype)
		
		if self.server != "error":
			self.numMessages = len ( self.server.list()[1] )
			self.newMessages = ''
			self.newMessagesList = ''
			self.size = self.server.stat()[1]
			self.uids = self._getUids()
			self.item = self._getItems()
			try:
				self.server.quit()
			except:
				pass
		else:
			self.error = True

	def _getUids(self):
		# get uid of individual message and append it in a list
		uids = []
		uidList = self.server.uidl()[1]

		#for i in range (self.numMessages):
		for i in range ( len(uidList) ):
			uidOfEmail = uidList[i].split()
			uids.append(uidOfEmail[1])
			
		return uids
	
	def _getItems(self):
		# list items on server - WORKING !!!
		emailList = []
		countNew = 0
		ok = True
		
		if ok:
			# get list of emails from the DB file for comparison - this method speeds up the mail checking process
			previousMail = self.mailbox
			oldUids = []
			for i in range ( len (previousMail.item) ):
				oldUids.append ( previousMail.item[i].uid )
			
			if len(previousMail.item) != self.numMessages:
				self.mustBeSaved = True
			
			for i in range (self.numMessages):
				if not self.uids[i] in oldUids:
					try:
						response, lines, bytes = self.server.top(i+1, MAXLINES)
						#response, lines, bytes = self.server.list(i+1)
						
						# get e-mail size
						bytes = self.server.list(i+1).split()[2]
						bytes = str ( int(bytes) / 1024 )
						
						# NEW METHOD (email.Parser)
						
						p = email.Parser.Parser()
						msg = p.parsestr('\n'.join(lines), headersonly=True)
						
						# check if mail has attachment
						multi = 0
						for part in msg.walk():
							if part.get_content_type().startswith('multipart/mixed'):
							#if msg.is_multipart() and not part.get_content_type().startswith('text') and  not part.get_content_type().startswith('multipart'):
								multi = 1
						#print "________________"
						
						# sender's e-mail address
						sender = decodeHeader(msg.__getitem__("from"))
						
						# e-mail subject
						subject = decodeHeader(msg.__getitem__("subject"))
						
						# e-mail date
						try:
							date = decodeHeader(msg.__getitem__("date"))
							plus = date.find("+")
							minus = date.find("-")
							if plus > -1:
								date = date[:plus-1]
							if minus > -1:
								date = date[:minus-1]
						except:
							date = getCurrentTime()
						
						"""
						print "Message %d (%d bytes)" % ( i+1, bytes)
						print "-" * 30
						#print response, lines
						
						print "id:",self.uids[i]
						print "\n".join(filter(rx_date.match, lines))
						print "\n".join(filter(rx_from.match, lines))
						print "\n".join(filter(rx_subject.match, lines))
						#print "\n".join(filter(rx_headers.match, lines))
						print "-" * 30
						"""
						
						"""
						# GOOD OLD METHOD
						
						try:
							multipart = filter(rx_multipart.match, lines)[0][14:]
							if multipart.find("mixed") > -1:
								multi = True
							else:
								multi = False
						except:
							multi = False
						
						try:
							date = filter(rx_date.match, lines)[0][6:]
							dedex = date.find("+")
							#print "dedex", dedex
							if dedex > -1:
								date = date[:dedex-1]
								print date
						except:
							date = getCurrentTime()
			
						try:
							subject = filter(rx_subject.match, lines)[0][9:]
						except: # catch empty subjects
							subject = " "
						
						try:
							sender = filter(rx_from.match, lines)[0][6:]
						except:
							sender = " "
						"""
						self.mustBeSaved = True
						self.newItems.append(i)
						
						emailList.append( emailContent(self.uids[i], date, sender, subject, bytes, multi, 1) )
						countNew += 1
					except:
						self.error = True
						break
				else:
					dex = oldUids.index(self.uids[i])
					
					if previousMail.item[dex].isMultipart == False:
						multi = 0
					else:
						multi = 1
						
					if previousMail.item[dex].new == 1:
						countNew += 1
					
					emailList.append( emailContent(previousMail.item[dex].uid, previousMail.item[dex].date, previousMail.item[dex].sender, previousMail.item[dex].subject, previousMail.item[dex].size, multi, previousMail.item[dex].new) )
					
			self.newMessages = countNew
		else:
			self.mustBeSaved = True
			self.newMessages = self.numMessages
			# get all messages from the pop, no comparison with DB file - Slower method
			for i in range (self.numMessages):
				try:
					response, lines, bytes = self.server.top(i+1, MAXLINES)
					#response, lines, bytes = self.server.list(i+1)
					bytes = self.server.list(i+1).split()[2]
					bytes = str ( int(bytes) / 1024 )
					
					# NEW METHOD (email.Parser)
					
					p = email.Parser.Parser()
					msg = p.parsestr('\n'.join(lines), headersonly=True)
					
					# retrieve e-mail sender
					sender = decodeHeader(msg.__getitem__("from"))
					
					# retrieve e-mail subject
					subject = decodeHeader(msg.__getitem__("subject"))
					
					# check if mail has attachment
					multi = 0
					for part in msg.walk():
						if not part.get_content_type().startswith('text') and not part.get_content_type().startswith('multipart'):
							multi = 1
	
					# retrieve e-mail date + small filter
					try:
						date = decodeHeader(msg.__getitem__("date"))
						plus = date.find("+")
						minus = date.find("-")
						if plus > -1:
							date = date[:plus-1]
						if minus > -1:
							date = date[:minus-1]
					except:
						date = getCurrentTime()
					
					# OLD METHOD
					"""
					try:
						multipart = filter(rx_multipart.match, lines)[0][14:]
						if multipart.find("multi") > -1:
							multi = True
						else:
							multi = False
					except:
						multi = False
					
					date = filter(rx_date.match, lines)[0][6:]
					dedex = date.find("+")
					print "dedex", dedex
					if dedex > -1:
						date = date[:dedex-1]
						print date
		
					try:
						subject = filter(rx_subject.match, lines)[0][9:]
					except: # catch empty subjects
						subject = " "
				
					sender = filter(rx_from.match, lines)[0][6:]
					"""
					
					emailList.append( emailContent(self.uids[i], date, sender, subject, bytes, multi, 1) )
				except:
					self.error = True
					break

		return emailList

class mailboxFromFile:
	def __init__(self, configfile):
		self.configfile = configfile
		self.newMessages = 0
		self.newItems = []
		self.con = sqlite.connect(DB_PATH)
		self.cur = self.con.cursor()
		self.getAccountSettings()
		self.getItems()
		self.con.close()
		
	def getAccountSettings(self):
		# read account settings from DB
		self.cur.execute("SELECT name, host, user, password, lastcheck, size, port, type FROM accounts WHERE name=?", (self.configfile,))
		
		for row in self.cur:
			self.accountname  = row[0]
			self.servername  = row[1]
			self.username  = row[2]
			self.password  = row[3]
			self.lastcheck  = row[4]
			self.size = row[5]
			self.port = row[6]
			self.servertype = row[7]

	def getItems(self):
		# get list of emails items from DB
		emailObject = []
		count = 0
		countNew = 0
		bytes = 0
		
		self.cur.execute("SELECT uid, date, sender, subject, size, multipart, new FROM mailboxes WHERE account=?", (self.configfile,))

		for row in self.cur:
			emailObject.append( emailContent (row[0], row[1], row[2], row[3], row[4], row[5], row[6]) )
			count += 1
			if int(row[6]) == 1:
				countNew += 1
		
		self.item = emailObject
		self.numMessages = count
		self.newMessages = countNew

# ------------------------------------------------------

class showAccountDialog(accountForm):
	def __init__(self, parent, mode, mailbox):
		accountForm.__init__(self, parent)
		#self.setModal(True)
		self.parent = parent
		# modes : (0) account creation / (1) account editing
		self.mode = mode
		if mode == 1:
			self.readSettings(mailbox)
			
		self.connect(self.pbOk, SIGNAL("clicked()"), self.saveSettings)
		self.connect(self.pbCancel, SIGNAL("clicked()"), self, SLOT("close()"))

	def readSettings(self, mailbox):
		#mailbox = self.parent.mailboxes[self.parent.kbSelectAccount.currentItem()]
		self.leAccount.setText( mailbox.accountname )
		self.leServer.setText( mailbox.servername )
		self.leUser.setText( mailbox.username )
		self.lePassword.setText( mailbox.password )
		if mailbox.port is not None:
			self.lePort.setText( str(mailbox.port) )
		if str(mailbox.servertype) != "" and mailbox.servertype is not None:
			self.kbSelectServerType.setCurrentItem(int(mailbox.servertype))
		if self.mode == 1:
			self.leAccount.setDisabled(True)

	def saveSettings(self):
		account = str ( self.leAccount.text() )
		server = str ( self.leServer.text() )
		user = str ( self.leUser.text() )
		password = str ( self.lePassword.text() )
		port = str( self.lePort.text() )
		servertype = self.kbSelectServerType.currentItem()
		
		# check account name : user must provide an account name
		if len(account) < 1:
			print "you must provide an account name."
			KMessageBox.error(self, "You must provide an account name.","Account Name Error" )
			return
		
		# checking account informations from the POP server on the fly
		self.setCursor( QCursor(3) ) # change mouse cursor shape
		print servertype, port
		mailboxCheck = _connect2Mailbox(server, user, password, port, servertype)
		self.setCursor( QCursor(0) ) # restore mouse cursor shape
		if mailboxCheck == "error":
			print "your account informations are invalid."
			KMessageBox.error(self, "Mailbox test ended with errors.\nPlease check your settings.","Mailbox Test Error" )
			return
		
		# building mailbox filename
		mailbox = account
		
		# check if account name already exists
		con = sqlite.connect(DB_PATH)
		cur = con.cursor()
		cur.execute( "SELECT name FROM accounts" )
		accountExists = False
		
		for row in cur:
			if account == row[0]:
				accountExists = True
				break
			
		# delete account with same name in DB if user is ok
		if accountExists and self.mode == 0:
			choice = KMessageBox.warningYesNo(self, "This account name already exists.\nOverwrite anyway ?","Account Name already exists" )
			if choice == 4: # if user says 'no'
				con.close()
				return
			else:
				cur.execute( "DELETE FROM accounts WHERE name=?", (account,) )
				cur.execute( "DELETE FROM mailboxes WHERE account=?", (account,) )
	
		# insert mailbox reference in DB
		cur.execute( "INSERT INTO accounts (host, lastcheck, name, password, size, user, type, port) VALUES (?, ?, ?, ?, ?, ?, ?, ?)", (server, "", account, password, 0, user, servertype, port) )
		con.commit()
		con.close()

		# make the parent dialog aware of the new settings
		#self.parent.parent.displayNewMailbox(mailboxFromFile(account))
		event = QCustomEvent(20000)
		event.setData( mailboxFromFile(account) )
		#event.setData( account )
		QThread.postEvent(self.parent, event)
		#self.parent.parent.loadSettings()
		self.parent.parent.layout10.setItemEnabled(0,True) # re-enable refresh button in toolbar
		
		# close window
		self.timeToQuit()
		# ptet mettre un return account a la place du time to quit

	def timeToQuit(self):
		self.close()

# ----------------------------------------------------------------------------------------------------------------------

class showSettingsDialog(settingsFormNew):
	def __init__(self,parent):
		settingsFormNew.__init__(self,parent)
		self.parent = parent
		self.spMainTimer.setRange( 1, 60 )
		self.readSettings()
		self._connectSlots()
	
	def _connectSlots(self):
		self.connect(self.pbEditAccount, SIGNAL("clicked()"), self.showAccountSettings)
		self.connect(self.pbCreateAccount, SIGNAL("clicked()"), self.createAccountSettings)
		self.connect(self.pbDeleteAccount, SIGNAL("clicked()"), self.deleteAccount)
		self.connect(self.pbOk, SIGNAL("clicked()"), self.saveSettings)
		self.connect(self.pbExternalApp, SIGNAL("clicked()"), self.requestExternalAppFile)
		self.connect(self.pbSoundGroup, SIGNAL("clicked()"), self.requestWaveFile)
		self.connect(self.pbCancel, SIGNAL("clicked()"), self, SLOT("close()"))

	def customEvent(self, event):
		if event.type() == 20000:
			self.parent.displayNewMailbox( event.data() )
			#self.readSettings()
			# find mailbox config file(s) available in DB & fill ComboBox
			self.kbSelectAccount.clear()
			itemIndex = 0
			if self.parent.accountConfigFileList:
				self.mailboxes = self.parent.accountConfigFileList
				#self.mailboxes = self.parent.mailboxes
				for name in self.mailboxes:
					self.kbSelectAccount.insertItem(name, itemIndex)
					itemIndex += 1
				if len(self.mailboxes) > 0:
					self.pbEditAccount.setDisabled(False)
					self.pbDeleteAccount.setDisabled(False)
				else:
					self.pbEditAccount.setDisabled(True)
					self.pbDeleteAccount.setDisabled(True)

	def requestExternalAppFile(self):
		clientChoice = str(KFileDialog.getOpenFileName( HOMEDIR, "", self, "Choose External Application" ))
		if clientChoice.strip() != "":
			self.leExternalApp.setText(clientChoice)
	
	def requestWaveFile(self):
		waveFileChoice = str(KFileDialog.getOpenFileName( HOMEDIR, "*.wav", self, "Choose Wave File" ))
		if waveFileChoice.strip() != "":
			self.leSoundGroup.setText(waveFileChoice)

	def showAccountSettings(self):
		if self.kbSelectAccount.count() > 0:
			self.accountSettingsDialog = showAccountDialog(self, 1, self.parent.mailboxes[self.kbSelectAccount.currentItem()])
			self.accountSettingsDialog.show()
		
	def createAccountSettings(self):
		self.accountSettingsDialog = showAccountDialog(self, 0, None)
		self.accountSettingsDialog.show()

	def saveSettings(self):
		"""save settings"""
		
		# read settings entered by end user
		startMinimized = "0"
		confirmDelete = "0"
		confirmClose = "0"
		saveUi = "0"
		if self.parent.isMaximized() == False:
			startMaximized = "0"
		else:
			startMaximized = "1"

		if self.cbStartMinimized.isOn(): startMinimized = "1"
		if self.cbConfirmDelete.isOn(): confirmDelete = "1"
		if self.cbConfirmClose.isOn(): confirmClose = "1"
		if self.cbSaveUi.isOn(): saveUi = "1"
		
		intervalTimer = str ( self.spIntervalTimer.value() )
		mainTimer = str ( self.spMainTimer.value() )
		
		# saving the rc settings file
		new_conf = open( CONFIG_FILERC, 'w' )
		new_conf.write( '[DEFAULT]\n' )
		new_conf.write( 'startminimized = ' + startMinimized + '\n' )
		new_conf.write( 'saveui = ' + saveUi + '\n' )
		new_conf.write( 'confirmclose = ' + confirmClose + '\n' )
		new_conf.write( 'confirmdelete = ' + confirmDelete + '\n' )
		new_conf.write( 'intervaltimer = ' + intervalTimer + '\n' )
		new_conf.write( 'maintimer = ' + mainTimer + '\n' )
		new_conf.write( 'startmaximized = ' + startMaximized + '\n' )
		new_conf.write( 'listview1height = ' + str( self.parent.listView1.height() ) + '\n' )
		new_conf.write( 'listview2height = ' + str( self.parent.listView2.height() ) + '\n' )
		new_conf.write( 'column1 = ' + str( self.parent.listView2.columnWidth(2) ) + '\n' )
		new_conf.write( 'column2 = ' + str( self.parent.listView2.columnWidth(3)  ) + '\n' )
		new_conf.write( 'column3 = ' + str( self.parent.listView2.columnWidth(4)  ) + '\n' )
		new_conf.write( 'width = ' +  str( self.parent.width() ) + '\n' )
		new_conf.write( 'height = ' + str( self.parent.height() ) + '\n' )
		new_conf.write( 'xpos = ' +  str( self.parent.x() ) + '\n' )
		new_conf.write( 'ypos = ' + str( self.parent.y() ) + '\n' )
		new_conf.write( 'lastaccountselected = ' + str( self.parent.accountSelected ) + '\n' )
		new_conf.write( 'externalapp = ' + str( self.leExternalApp.text() ).strip() + '\n' )
		new_conf.write( 'audiowavefile = '+ str( self.leSoundGroup.text() ).strip() + '\n' )
		new_conf.close()
		
		# make the main app aware of the new settings
		self.parent.loadSettings()
		
		# close window
		self.timeToQuit()
	
	def readSettings(self):

		if os.path.exists(CONFIG_FILERC):
			self.configfile = ConfigParser()
			self.configfile.read(CONFIG_FILERC)
			
			self.spIntervalTimer.setValue( int(self.configfile.defaults()['intervaltimer']) )
			self.spMainTimer.setValue( int(self.configfile.defaults()['maintimer']) )
			
			self.cbStartMinimized.setOn( int(self.configfile.defaults()['startminimized']) )
			self.cbConfirmDelete.setOn( int(self.configfile.defaults()['confirmdelete']) )
			self.cbConfirmClose.setOn( int(self.configfile.defaults()['confirmclose']) )
			self.cbSaveUi.setOn( int(self.configfile.defaults()['saveui']) )
			
			self.leExternalApp.setText( self.configfile.defaults()['externalapp'] )
			try:
				self.leSoundGroup.setText( self.configfile.defaults()['audiowavefile'] )
			except:
				pass
		
		# find mailbox config file(s) available in DB & fill ComboBox
		self.kbSelectAccount.clear()
		itemIndex = 0
		if self.parent.accountConfigFileList:
			self.mailboxes = self.parent.accountConfigFileList
			#self.mailboxes = self.parent.mailboxes
			for name in self.mailboxes:
				self.kbSelectAccount.insertItem(name, itemIndex)
				itemIndex += 1

		if self.kbSelectAccount.count() > 0:
			self.pbEditAccount.setDisabled(False)
			self.pbDeleteAccount.setDisabled(False)
		else:
			self.pbEditAccount.setDisabled(True)
			self.pbDeleteAccount.setDisabled(True)

		# TODO : inform main app ?!?

	def deleteAccount(self):
		if self.kbSelectAccount.count() == 0:
			return

		deleteBtn = KGuiItem("&Delete", "", "", "")
		cancelBtn = KGuiItem("&Cancel", "", "", "")
		choice = KMessageBox.warningYesNo(self, "Proceed with account " + str(self.kbSelectAccount.currentText()) + " deletion ?", "Confirm account deletion", deleteBtn, cancelBtn )
		if choice == 4: # if user says 'no'
			return
		
		currentItem = self.kbSelectAccount.currentItem()
		currentBoxName = str(self.kbSelectAccount.currentText())
		
		try:
			# remove mailbox from DB
			con = sqlite.connect(DB_PATH)
			cur = con.cursor()
			cur.execute( "DELETE FROM accounts WHERE name=?", (self.mailboxes[currentItem],) )
			cur.execute( "DELETE FROM mailboxes WHERE account=?", (self.mailboxes[currentItem],) )
			con.commit()
			con.close()
			
			# remove mailbox name from Combo Box list
			self.kbSelectAccount.removeItem( currentItem )
			
			# remove mailbox item from Array list -- using pop() array function
			pignouf = self.mailboxes.pop(currentItem)
			
			# remove mailbox from main window -- using pop() array function
			self.parent.listView1.takeItem(self.parent.accountHeader[currentItem])
			pignouf = self.parent.accountHeader.pop(currentItem)
			pignouf = self.parent.mailboxes.pop(currentItem)
			if len(self.parent.accountHeader) > 0:
				if currentItem == self.parent.accountSelected:
					self.parent.accountSelected = 0
					self.parent.displayMailboxes(False)
			else:
				self.pbEditAccount.setDisabled(True)
				self.pbDeleteAccount.setDisabled(True)
				self.parent.accountSelected = 0
				self.parent.listView2.clear()
				self.parent.layout10.setItemEnabled(0,False)
			
			print "account", currentBoxName, "has been deleted"
		
		except:
			print "error occured deleting account."
	
	def timeToQuit(self):
		self.close()

# ----------------------------------------------------------------------------------------------------------------------

class showEmailsDialog(showEmailsForm):
	def __init__(self, parent, infos, uids):
		showEmailsForm.__init__(self, parent)
		self.serverInfos = infos
		self.uids2Show = uids
		self.parent = parent
		self.numMessages = 0
		self.index = 0
		self.pbNext.setDisabled(True)
		self.pbBack.setDisabled(True)
		self.startTimer = QTimer(self)
		
		self._connectSlots()
		
		self.startTimer.start(20)
		#self.initMessages()
	
	def _connectSlots(self):
		self.connect(self.pbBack, SIGNAL("clicked()"), self.onBackClicked)
		self.connect(self.pbNext, SIGNAL("clicked()"), self.onNextClicked)
		self.connect(self.pbReply, SIGNAL("clicked()"), self.onReplyClicked)
		self.connect(self.pbToggle, SIGNAL("clicked()"), self.onToggleClicked)
		self.connect(self.pbUndelete, SIGNAL("clicked()"), self.onUndeleteClicked)
		self.connect(self.pbDelete, SIGNAL("clicked()"), self.onDeleteClicked)
		self.connect(self.pbClose, SIGNAL("clicked()"), self.timeToQuit)
		self.connect(self.startTimer, SIGNAL("timeout()"), self.initMessages)
		#self.connect(self.pbClose, SIGNAL("clicked()"), self, SLOT("close()"))

	def customEvent(self, event):
		# mail has been RETRIEVED (thread operation has stopped)
		if event.type() == 81000:
			if self.waitDialog:
				self.waitDialog.close()
			
			if event.data() == "error":
				KMessageBox.error(self, "Could not connect to mailbox !\nDialog will close now.","Network ERROR" )
				self.close()
			else: # load values & init view
				self.messages = event.data()
				
				if self.messages:
					self.numMessages = len (self.messages)

				if self.numMessages > 1:
					self.pbNext.setDisabled(False)
				
				if self.numMessages > 0:
					self.setCaption( "Email #" + str( self.messages[self.index].index ) + " (" + str(self.index+1) + "/" + str(len(self.messages)) + ")" )
					self.txtBrowser.setText( self.messages[self.index].messageDecoded )

		# mail has been DELETED (thread operation has stopped)
		if event.type() == 50000:
			if self.waitDialog:
				self.waitDialog.close()
			
			if event.data() == "error":
				print "Connection error occured"
				KMessageBox.error(self, "Could not connect to mailbox !\nDialog will close now.","Network ERROR" )
			else:
				# successfully delete uids in event.data()'s list from server
				if len(event.data()) < 1:
					print "no message has been deleted"
				else:
					print len(event.data()),"message(s) have been deleted"
			
				self.parent.updateMailbox()
			
			self.close()
		
		# Connection to mailbox error occured (from delete thread)
		"""
		if event.type() == 60000:
			print "Connection error occured"
			if self.waitDialog:
				self.waitDialog.close()
			
			KMessageBox.error(self, "Could not connect to mailbox !\nDialog will close now.","Network ERROR" )
			
			self.close()
		"""

	def initMessages(self):
		self.startTimer.stop()
		
		self.retrieveMailThread = _retrieveMailThread(self, self.serverInfos, self.uids2Show)
		self.retrieveMailThread.start()
		
		self.waitDialog = showWaitForm(self)
		self.waitDialog.show()

	def onReplyClicked(self):
		print "launching KMail compose window..."
		
		# prepare data
		subject = self.messages[self.index].subject.replace('"', '\\"')
		sender = self.messages[self.index].sender.replace('"', '\\"')
		body = self.messages[self.index].messageDecoded.replace('"', '\\"')
		body = body.replace('\n', '\n>')
		
		# launch KMail composer
		os.popen2( u'kmail --composer -s "Re:%s" --body "%s" "%s"' % (subject, body, sender) )

	def onUndeleteClicked(self):
		self.messages[self.index].deleted = False

		self.pbUndelete.setDisabled(True)
		self.pbDelete.setDisabled(False)
		self.txtBrowser.setDisabled(False)

	def onDeleteClicked(self):
		self.messages[self.index].deleted = True

		self.pbDelete.setDisabled(True)
		self.pbUndelete.setDisabled(False)
		self.txtBrowser.setDisabled(True)

	def onToggleClicked(self):
		if self.messages[self.index].toggled:
			self.messages[self.index].message = self.messages[self.index].messageDecoded
			self.messages[self.index].toggled = False
		else:
			self.messages[self.index].message = self.messages[self.index].messageSource
			self.messages[self.index].toggled = True
		
		self.txtBrowser.setText(self.messages[self.index].message)

	def onBackClicked(self):
		self.index -= 1
		
		if self.index == 0:
			self.pbBack.setDisabled(True)
		
		if self.index == ( self.numMessages - 2 ):
			self.pbNext.setDisabled(False)
		
		if self.messages[self.index].deleted:
			self.pbDelete.setDisabled(True)
			self.pbUndelete.setDisabled(False)
		else:
			self.pbDelete.setDisabled(False)
			self.pbUndelete.setDisabled(True)
		
		self.setCaption( "Email #" + str( self.messages[self.index].index ) + " (" + str(self.index+1) + "/" + str(len(self.messages)) + ")" )
		
		self.txtBrowser.setText( self.messages[self.index].message )
		self.txtBrowser.setCursorPosition ( 0, 0 )
		self.txtBrowser.setDisabled(self.messages[self.index].deleted)

	def onNextClicked(self):
		self.index += 1
		
		if self.index == ( self.numMessages - 1 ):
			self.pbNext.setDisabled(True)
		
		if self.index == 1:
			self.pbBack.setDisabled(False)
			
		if self.messages[self.index].deleted:
			self.pbDelete.setDisabled(True)
			self.pbUndelete.setDisabled(False)
		else:
			self.pbDelete.setDisabled(False)
			self.pbUndelete.setDisabled(True)
		
		self.setCaption( "Email #" + str( self.messages[self.index].index ) + " (" + str(self.index+1) + "/" + str(len(self.messages)) + ")" )
		
		self.txtBrowser.setText( self.messages[self.index].message )
		self.txtBrowser.setCursorPosition ( 0, 0 )
		self.txtBrowser.setDisabled(self.messages[self.index].deleted)
	
	def showWaitDialog(self, title, text, width, height):
		self.waitDialog = QDialog(self, 'waitDialog', 1, 0)
		
		self.waitDialog.setCaption(title)
		
		waitLayout = QVBoxLayout(self.waitDialog,6,6,"waitLayout")
		
		waitLabel = QLabel(self.waitDialog, 'waitLabel')
		waitLabel.setText( '\n' + text + '\n' )
		
		waitLayout.addWidget(waitLabel)

		self.waitDialog.show()
	
	def timeToQuit(self):
		# find items that have to be deleted
		itemsList = []
		index = 0
		for item in self.messages:
			if item.deleted:
				itemsList.append(item.uid)
			index += 1
		
		if len(itemsList) > 0:
			# display message dialog
			deleteBtn = KGuiItem("&Delete", "", "", "")
			noBtn = KGuiItem("&Quit", "", "", "")
			cancelBtn = KGuiItem("&Cancel", "", "", "")
			
			choice = KMessageBox.warningYesNoCancel(self, 
													str(len(itemsList) ) + " messages have been marked.\n"
													"Do you want to delete these messages ?", 
													"Delete E-mails", 
													deleteBtn, 
													noBtn )
			
			if choice == 3: # if user says 'delete' -> delete e-mail(s) from server
				#print "must delete this items", itemsList
				self.deleteMailThread = _deleteMailThread(self, self.serverInfos, itemsList)
				self.deleteMailThread.start()
		
				if not self.waitDialog:
					self.waitDialog = showWaitForm(self)
				
				self.waitDialog.show()
				"""
				event = QCustomEvent(self.parent.evtDeleteEmailList)
				event.setData(itemsList)
				qApp.sendEvent(self.parent, event)
				"""
			elif choice == 2: # if user says 'cancel' -> do nothing
				return

		self.close()

"""
class RichTextItem(KListViewItem):

    def __init__(self, parent, previous = None):
    
        KListViewItem.__init__(self, parent, previous)
        self.label = QLabel(None)
    
    def paintCell(self, painter, colorGroup, column, width, alignment):
    
        painter.save()
        painter.fillRect(0, 0, width, self.height(), QBrush(Qt.white))
        self.label.setText(self.text(column))
        self.label.resize(width, self.height())
        pixmap = QPixmap.grabWidget(self.label, 0, 0, width, self.height())
        painter.drawPixmap(0, 0, pixmap)
        painter.restore()

class RichTextItemQ(QListViewItem):

    def __init__(self, parent, previous = None):
    
        QListViewItem.__init__(self, parent, previous)
        self.label = QLabel(None)
    
    def paintCell(self, painter, colorGroup, column, width, alignment):
    
        painter.save()
        painter.fillRect(0, 0, width, self.height(), QBrush(Qt.white))
        self.label.setText(self.text(column))
        self.label.resize(width, self.height())
        pixmap = QPixmap.grabWidget(self.label, 0, 0, width, self.height())
        painter.drawPixmap(0, 0, pixmap)
        painter.restore()
"""

# ================================================================
# LAUNCH APPLICATION
# ================================================================

"""getting & setting path where ressources are located"""
appRoot = os.path.dirname(os.path.realpath(__file__))
os.chdir(os.path.dirname(os.path.realpath(__file__)))
#appRoot = os.path.dirname(os.path.abspath(os.path.realpath(sys.argv[0])))

"""set KDE application informations"""
appName = "KPopAssistant"
appVersion = "0.3"
aboutData = KAboutData("mail_generic", appName, appVersion, __doc__, KAboutData.License_GPL, "(c) 2007, Thierry Deseez.\nReleased under the GNU General Public License version 2.0.")
#aboutData = KAboutData ("kmail", "icon", "1.0", "icon", KAboutData.License_GPL, "")
#If you want to use something other than the "kmail" icon (which I imagine you do), you'll need to install the icon somewhere in the kde3/share/icons hierarchy
aboutData.setShortDescription ("A multi-pop mail checker for KDE with extended features.")
aboutData.setVersion ("0.3")
aboutData.setHomepage("http://www.kde-apps.org/")
aboutData.setOtherText("Written in pyKDE.")
aboutData.setProgramName("KPopAssistant")
aboutData.addAuthor ("Thierry Deseez", "Author", "pizza.tony@laposte.net", "http://www.kde-apps.org")

"""do launch Kde app"""
args = KCmdLineArgs.init(sys.argv, aboutData)
app = KApplication()
#app = KApplication (sys.argv, appName)
#app.enableSessionManagement()

mainWin = KPopAssistant(None)
#mainWinConfig = app.config()
#mainWin = KPopAssistant(mainWinConfig)
#mainWin.setupGUI(KMainWindow.Create | KMainWindow.Save)

"""start app hidden in systray or not"""
if mainWin.startMinimized == 0:
	mainWin.show()
if mainWin.startMaximized == 1:
	mainWin.showMaximized()

app.exec_loop()